#include <windows.h>
#include <mmsystem.h>
#include <stdio.h>
#include "midi.h"


static char RetString[80];
bool Playing = false;

bool Repeating = false;
bool Intro = false;


bool LoadMIDI(char *filename)
{
  char TempString[300];
  CloseMIDI();
  sprintf(TempString, "open \"%s\" type sequencer alias midifile", filename);
  mciSendString(TempString, RetString, 70, NULL);
  return true;
}


bool CloseMIDI()
{
  mciSendString("close midifile", RetString, 70, NULL);
  Playing = false;
  return true;
}


long GetMIDILength()
{
  mciSendString("status midifile length", RetString, 70, NULL);
  return atoi(RetString);
}


long GetMIDIPos()
{
  mciSendString("status midifile position", RetString, 70, NULL);
  return atoi(RetString);
}


bool SetMIDIPos(long position)
{
  char TempString[80];
  if (!Playing) return false;
  sprintf(TempString, "seek midifile to %ld", position);
  mciSendString(TempString, RetString, 70, NULL);
  PlayMIDI();
  return true;
}


bool MIDIQueryPlaying()
{
  return Playing;
}


bool MIDIQueryStopped()
{
  mciSendString("status midifile mode", RetString, 70, NULL);
  if (strcmp(RetString, "stopped") == 0)
    return true;
  return false;
}


bool PlayMIDI()
{
  char TempString[300];

  sprintf(TempString, "play midifile");
  mciSendString(TempString, RetString, 70, NULL);
  Playing = true;
  return Playing;
}


bool PauseMIDI()
{
  mciSendString("pause midifile", RetString, 70, NULL);
  Playing = false;
  return true;
}


bool StopMIDI()
{
  mciSendString("pause midifile", RetString, 70, NULL);
  mciSendString("seek midifile to start", RetString, 70, NULL);
  Playing = false;
  return true;
}


bool ToggleRepeat()
{
  if (Repeating) Repeating = false;
  else           Repeating = true;
  return true;
}


bool GetRepeat()
{
  return Repeating;
}


bool SetRepeat(bool value)
{
  Repeating = value;
  return true;
}


bool ToggleIntro()
{
  if (Intro) Intro = false;
  else       Intro = true;
  return true;
}


bool GetIntro()
{
  return Intro;
}


bool SetIntro(bool value)
{
  Intro = value;
  return true;
}
